extends Spatial

export var spawn_delay = 0.5

var enemy_scn = preload("res://Objects/Enemy1.scn")

onready var info_panel = get_node("../InfoDisplay")
onready var enemy_root = get_parent()

var spawn_timer = Timer.new()
var to_spawn = 0
var last_spawn_time = spawn_delay
var can_spawn = false

func _fixed_process(delta):
	if !can_spawn:
		return
	
	last_spawn_time += delta
	if last_spawn_time >= spawn_delay:
		last_spawn_time -= spawn_delay
		if to_spawn == 0:
			last_spawn_time = spawn_delay
			can_spawn = false
			return
			
		spawn_enemy()
		to_spawn -= 1
		info_panel.update_spawn(to_spawn)

func spawn_enemy():
	var enemy = enemy_scn.instance()
	enemy.set_translation(get_translation())
	enemy_root.add_child(enemy)

# Force a wave to be spawned
func force_spawn_wave():
	spawn_timer.set_wait_time(20)
	_start_wave()

# Start a wave of enemy spawns
func _start_wave():
	to_spawn += 5
	can_spawn = true
	info_panel.update_spawn(to_spawn)

func _ready():
	spawn_timer.connect("timeout", self, "_start_wave")
	spawn_timer.set_wait_time(20)
	spawn_timer.start()
	add_child(spawn_timer)
	set_fixed_process(true)
