extends Spatial

onready var head = get_node("TurretBaseStandard/TurretHeadStandard")
onready var area = get_node("Area")

var fire_timer = Timer.new()

func _fixed_process(delta):
	fire()
	pass

# Fire a bullet at the nearest enemy
func fire():
	var bodies = area.get_overlapping_bodies()
	if bodies.size() == 0:
		return
	
	var translation = get_translation()
	var curr_body
	var body_distance = 0
	for body in bodies:
		var dist = body.get_translation().distance_squared_to(translation)
		if curr_body == null || body_distance > dist:
			curr_body = body
			body_distance = dist
	
	head.look_at(curr_body.get_translation(), Vector3(0,1,0))

func _ready():
	fire_timer.connect("timeout", self, "fire")
	set_fixed_process(true)
